/*
 *
 * cache.h
 *
 * Author: Landon Fuller <landonf@circus-foundation.org>
 *
 * Copyright (c) 2000-2001 InfoSpace, Inc. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *         This product includes software developed by InfoSpace, Inc.
 *         and its contributors.
 * 4. Neither the name of InfoSpace, Inc nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

struct mapcache {
	mapname *map;
	sem_t *sem;
	time_t time;
	struct mapentry *mapentry;
	struct mapcache *next;
};

struct mapentry {
	char *key, *val;
	struct mapentry *next, *prev;
};

struct pwinfo {
	char *uid;
	char *userpassword;
	char *uidnumber;
	char *gidnumber;
	char *gecos;
	char *homedirectory;
	char *loginshell;
	size_t size;
};

struct gwinfo {
	char *cn;
	char *userpassword;
	char *gidnumber;
	char *memberuid;
	size_t size;
};

struct nisinfo {
	char *cn;
	char *nismapentry;
	char *nismapname;
};

struct mapcache *create_cache (ypmaplist *);
void maintain_cache (void);
ypstat yp_get_record(keydat *, mapname *, valdat *);
ypstat yp_first_record(keydat *, mapname *, valdat *);
ypstat yp_next_record(keydat *, mapname *, valdat *);
